Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 72321)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 72329)
@@ -934,6 +934,9 @@
     {
         /* Assign state-icons: */
-        setStateIcon(0, UIIconPool::iconSet(":/vtx_amdv_disabled_16px.png"));
-        setStateIcon(1, UIIconPool::iconSet(":/vtx_amdv_16px.png"));
+        setStateIcon(KVMExecutionEngine_NotSet, UIIconPool::iconSet(":/vtx_amdv_disabled_16px.png"));
+        setStateIcon(KVMExecutionEngine_RawMode, UIIconPool::iconSet(":/vtx_amdv_disabled_16px.png"));
+        setStateIcon(KVMExecutionEngine_HwVirt, UIIconPool::iconSet(":/vtx_amdv_16px.png"));
+        /** @todo new indicator icon, something that looks very very slow (at least on Windows)... @bugref{9044} */
+        setStateIcon(KVMExecutionEngine_NativeApi, UIIconPool::iconSet(":/vtx_amdv_disabled_16px.png"));
         /* Translate finally: */
         retranslateUi();
@@ -949,7 +952,24 @@
 
         /* VT-x/AMD-V feature: */
-        const QString strVirtualization = m_pSession->isHWVirtExEnabled() ?
-                                          VBoxGlobal::tr("Active", "details report (VT-x/AMD-V)") :
-                                          VBoxGlobal::tr("Inactive", "details report (VT-x/AMD-V)");
+        KVMExecutionEngine enmEngine = m_pSession->getVMExecutionEngine();
+        QString strExecutionEngine;
+        switch (enmEngine)
+        {
+            case KVMExecutionEngine_HwVirt:
+                strExecutionEngine = "VT-x/AMD-V";  /* no translation */
+                break;
+            case KVMExecutionEngine_RawMode:
+                strExecutionEngine = "raw-mode";    /* no translation */
+                break;
+            case KVMExecutionEngine_NativeApi:
+                strExecutionEngine = "native API";  /* no translation */
+                break;
+            default:
+                AssertFailed();
+                enmEngine = KVMExecutionEngine_NotSet;
+            case KVMExecutionEngine_NotSet:
+                strExecutionEngine = VBoxGlobal::tr("not set", "details report (execution engine)");
+                break;
+        }
 
         /* Nested Paging feature: */
@@ -971,5 +991,6 @@
         /* Prepare tool-tip: */
         QString strFullData;
-        strFullData += s_strTableRow2.arg(VBoxGlobal::tr("VT-x/AMD-V", "details report"),                   strVirtualization);
+        //strFullData += s_strTableRow2.arg(VBoxGlobal::tr("VT-x/AMD-V", "details report"),                   strVirtualization);
+        strFullData += s_strTableRow2.arg(VBoxGlobal::tr("Execution engine", "details report"),             strExecutionEngine);
         strFullData += s_strTableRow2.arg(VBoxGlobal::tr("Nested Paging"),                                  strNestedPaging);
         strFullData += s_strTableRow2.arg(VBoxGlobal::tr("Unrestricted Execution"),                         strUnrestrictExec);
@@ -978,10 +999,10 @@
         const int cpuCount = machine.GetCPUCount();
         if (cpuCount > 1)
-            strFullData += s_strTableRow2.arg(VBoxGlobal::tr("Processor(s)", "details report"), QString::number(cpuCount));
+            strFullData += s_strTableRow2.arg(VBoxGlobal::tr("Processors", "details report"), QString::number(cpuCount));
 
         /* Update tool-tip: */
         setToolTip(s_strTable.arg(strFullData));
         /* Update indicator state: */
-        setState(m_pSession->isHWVirtExEnabled());
+        setState(enmEngine);
     }
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 72321)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 72329)
@@ -956,4 +956,5 @@
     , m_fIsValidPointerShapePresent(false)
     , m_fIsHidingHostPointer(true)
+    , m_enmVMExecutionEngine(KVMExecutionEngine_NotSet)
     /* CPU hardware virtualization features for VM: */
     , m_fIsHWVirtExEnabled(false)
@@ -2121,4 +2122,6 @@
 void UISession::loadVMSettings()
 {
+    /* Cache IMachine::ExecutionEngine value. */
+    m_enmVMExecutionEngine = m_debugger.GetExecutionEngine();
     /* Load CPU hardware virtualization extension: */
     m_fIsHWVirtExEnabled = m_debugger.GetHWVirtExEnabled();
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 72321)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 72329)
@@ -266,4 +266,6 @@
     /** @name CPU hardware virtualization features for VM.
      ** @{ */
+    /** Returns whether CPU hardware virtualization extension is enabled. */
+    KVMExecutionEngine getVMExecutionEngine() const { return m_enmVMExecutionEngine; }
     /** Returns whether CPU hardware virtualization extension is enabled. */
     bool isHWVirtExEnabled() const { return m_fIsHWVirtExEnabled; }
@@ -543,4 +545,7 @@
     bool m_fIsHidingHostPointer : 1;
 
+    /** Copy of IMachineDebugger::ExecutionEngine */
+    KVMExecutionEngine m_enmVMExecutionEngine;
+
     /** @name CPU hardware virtualization features for VM.
      ** @{ */