Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 72343)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 72344)
@@ -30,5 +30,7 @@
         <file alias="cd_16px.png">images/cd_16px.png</file>
         <file alias="cd_add_16px.png">images/cd_add_16px.png</file>
+        <file alias="cd_add_22px.png">images/cd_add_22px.png</file>
         <file alias="cd_add_disabled_16px.png">images/cd_add_disabled_16px.png</file>
+        <file alias="cd_add_disabled_22px.png">images/cd_add_disabled_22px.png</file>
         <file alias="cd_copy_16px.png">images/cd_copy_16px.png</file>
         <file alias="cd_copy_22px.png">images/cd_copy_22px.png</file>
@@ -123,5 +125,7 @@
         <file alias="fd_16px.png">images/fd_16px.png</file>
         <file alias="fd_add_16px.png">images/fd_add_16px.png</file>
+        <file alias="fd_add_22px.png">images/fd_add_22px.png</file>
         <file alias="fd_add_disabled_16px.png">images/fd_add_disabled_16px.png</file>
+        <file alias="fd_add_disabled_22px.png">images/fd_add_disabled_22px.png</file>
         <file alias="fd_copy_16px.png">images/fd_copy_16px.png</file>
         <file alias="fd_copy_22px.png">images/fd_copy_22px.png</file>
@@ -166,5 +170,7 @@
         <file alias="hd_32px.png">images/hd_32px.png</file>
         <file alias="hd_add_16px.png">images/hd_add_16px.png</file>
+        <file alias="hd_add_22px.png">images/hd_add_22px.png</file>
         <file alias="hd_add_disabled_16px.png">images/hd_add_disabled_16px.png</file>
+        <file alias="hd_add_disabled_22px.png">images/hd_add_disabled_22px.png</file>
         <file alias="hd_copy_16px.png">images/hd_copy_16px.png</file>
         <file alias="hd_copy_22px.png">images/hd_copy_22px.png</file>
@@ -318,6 +324,4 @@
         <file alias="os_mandriva.png">images/os_mandriva.png</file>
         <file alias="os_netbsd_64.png">images/os_netbsd_64.png</file>
-        <file alias="os_netbsd.png">images/os_netbsd.png</file>
-        <file alias="os_netware.png">images/os_netware.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 72343)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 72344)
@@ -1,4 +1,6 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="os_netbsd.png">images/os_netbsd.png</file>
+        <file alias="os_netware.png">images/os_netware.png</file>
         <file alias="os_openbsd_64.png">images/os_openbsd_64.png</file>
         <file alias="os_openbsd.png">images/os_openbsd.png</file>
@@ -259,4 +261,5 @@
         <file alias="vm_discard_disabled_16px.png">images/vm_discard_disabled_16px.png</file>
         <file alias="vm_discard_disabled_32px.png">images/vm_discard_disabled_32px.png</file>
+        <file alias="vm_execution_engine_native_api_16px.png">images/vm_execution_engine_native_api_16px.png</file>
         <file alias="vm_group_create_16px.png">images/vm_group_create_16px.png</file>
         <file alias="vm_group_create_disabled_16px.png">images/vm_group_create_disabled_16px.png</file>
@@ -316,5 +319,4 @@
         <file alias="vtx_amdv_16px.png">images/vtx_amdv_16px.png</file>
         <file alias="vtx_amdv_disabled_16px.png">images/vtx_amdv_disabled_16px.png</file>
-        <file alias="vm_execution_engine_native_api_16px.png">images/vm_execution_engine_native_api_16px.png</file>
         <file alias="web_camera_16px.png">images/web_camera_16px.png</file>
         <file alias="web_camera_disabled_16px.png">images/web_camera_disabled_16px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 72343)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 72344)
@@ -49,7 +49,8 @@
 # include "COMEnums.h"
 # include "CMachine.h"
+# include "CMediumAttachment.h"
 # include "CMediumFormat.h"
 # include "CStorageController.h"
-# include "CMediumAttachment.h"
+# include "CSystemProperties.h"
 
 # ifdef VBOX_WS_MAC
@@ -825,5 +826,5 @@
     , m_pContextMenu(0)
     , m_pMenu(0)
-    , m_pActionCopy(0), m_pActionMove(0), m_pActionRemove(0)
+    , m_pActionAdd(0), m_pActionCopy(0), m_pActionMove(0), m_pActionRemove(0)
     , m_pActionRelease(0), m_pActionDetails(0)
     , m_pActionRefresh(0)
@@ -850,4 +851,10 @@
 
     /* Translate actions: */
+    if (m_pActionAdd)
+    {
+        m_pActionAdd->setText(UIMediumManager::tr("&Add..."));
+        m_pActionAdd->setToolTip(UIMediumManager::tr("Add Disk Image File (%1)"));
+        m_pActionAdd->setStatusTip(UIMediumManager::tr("Add disk image file"));
+    }
     if (m_pActionCopy)
     {
@@ -1199,4 +1206,10 @@
 }
 
+void UIMediumManagerWidget::sltAddMedium()
+{
+    QString strDefaultMachineFolder = vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder();
+    vboxGlobal().openMediumWithFileOpenDialog(currentMediumType(), this, strDefaultMachineFolder);
+}
+
 void UIMediumManagerWidget::sltCopyMedium()
 {
@@ -1398,4 +1411,12 @@
 void UIMediumManagerWidget::prepareActions()
 {
+    /* Create 'Add' action: */
+    m_pActionAdd = new QAction(this);
+    AssertPtrReturnVoid(m_pActionAdd);
+    {
+        /* Configure add-action: */
+        m_pActionAdd->setShortcut(QKeySequence("Ctrl+A"));
+        connect(m_pActionAdd, &QAction::triggered, this, &UIMediumManagerWidget::sltAddMedium);
+    }
     /* Create 'Copy' action: */
     m_pActionCopy = new QAction(this);
@@ -1469,4 +1490,6 @@
     {
         /* Configure 'Medium' menu: */
+        if (m_pActionAdd)
+            m_pMenu->addAction(m_pActionAdd);
         if (m_pActionCopy)
             m_pMenu->addAction(m_pActionCopy);
@@ -1497,4 +1520,6 @@
     {
         /* Configure contex-menu: */
+        if (m_pActionAdd)
+            m_pContextMenu->addAction(m_pActionAdd);
         if (m_pActionCopy)
             m_pContextMenu->addAction(m_pActionCopy);
@@ -1547,4 +1572,6 @@
         m_pToolBar->setToolButtonStyle(Qt::ToolButtonTextUnderIcon);
         /* Add toolbar actions: */
+        if (m_pActionAdd)
+            m_pToolBar->addAction(m_pActionAdd);
         if (m_pActionCopy)
             m_pToolBar->addAction(m_pActionCopy);
@@ -1827,4 +1854,11 @@
         }
     }
+
+    if (m_pActionAdd)
+        m_pActionAdd->setIcon(UIIconPool::iconSetFull(QString(":/%1_add_22px.png").arg(strPrefix),
+                                                       QString(":/%1_add_16px.png").arg(strPrefix),
+                                                       QString(":/%1_add_disabled_22px.png").arg(strPrefix),
+                                                       QString(":/%1_add_disabled_16px.png").arg(strPrefix)));
+
     if (m_pActionCopy)
         m_pActionCopy->setIcon(UIIconPool::iconSetFull(QString(":/%1_copy_22px.png").arg(strPrefix),
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 72343)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 72344)
@@ -161,4 +161,6 @@
     /** @name Menu/action stuff.
       * @{ */
+        /** Handles command to add medium. */
+        void sltAddMedium();
         /** Handles command to copy medium. */
         void sltCopyMedium();
@@ -344,4 +346,6 @@
         /** Holds the menu object instance. */
         QMenu     *m_pMenu;
+        /** Holds the Add action instance. */
+        QAction   *m_pActionAdd;
         /** Holds the Copy action instance. */
         QAction   *m_pActionCopy;
@@ -438,3 +442,2 @@
 
 #endif /* !___UIMediumManager_h___ */
-